﻿using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.FileProviders;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FileProvider
{
    public class HelloFileProviderMiddleware
    {
        private readonly RequestDelegate _next;
        private readonly IFileProvider _fileProvider;

        public HelloFileProviderMiddleware(RequestDelegate next, IFileProvider fileProvider)
        {
            _next = next;
            _fileProvider = fileProvider;
        }

        public async Task Invoke(HttpContext context)
        {
            //var output = new StringBuilder("");
            //IDirectoryContents dir = _fileProvider.GetDirectoryContents("");
            //foreach (IFileInfo item in dir)
            //{
            //    output.AppendLine(item.Name);
            //}
            //await context.Response.WriteAsync(output.ToString());


            //IFileInfo file = _fileProvider.GetFileInfo("Startup.cs");
            //using (var stream = file.CreateReadStream())
            //{
            //    using (var reader = new StreamReader(stream))
            //    {
            //        var output = await reader.ReadToEndAsync();
            //        await context.Response.WriteAsync(output.ToString());
            //    }
            //}

            var output = new StringBuilder("");
            ResolveDirectory(output, "", "");

            await context.Response.WriteAsync(output.ToString());
        }

        private void ResolveDirectory(StringBuilder output, string path, string prefix)
        {
            IDirectoryContents dir = _fileProvider.GetDirectoryContents(path);
            foreach (IFileInfo item in dir)
            {
                if (item.IsDirectory)
                {
                    output.AppendLine(prefix + "[" + item.Name + "]");

                    ResolveDirectory(output, 
                        item.PhysicalPath.Substring(Directory.GetCurrentDirectory().Length), 
                        prefix + "    ");
                } else
                {
                    output.AppendLine(prefix + item.Name);
                }
            }
        }
    }

    public static class UseHelloFileProviderExtensions
    {
        public static IApplicationBuilder UseHelloFileProvider(this IApplicationBuilder app)
        {
            return app.UseMiddleware<HelloFileProviderMiddleware>();
        }
    }
}
